@ECHO OFF
SETLOCAL
:binary to byte
:parameter is a 8 bit binary number
:output is decimal and hex
set bin=00000000%1
set bin=%bin:~-8,8%
set /a counter=0
set result=
call :b_loop 128 64 32 16 8 4 2 1
call :to_hex %result%
ENDLOCAL & set result=%result%& set hresult=%hresult%

goto :eof

:b_loop
set /a result=%result%+!bin:~%counter%,1!*%1
set /a counter+=1
shift
if %counter% LEQ 7 goto :b_loop
goto :eof

:to_hex
set /a hinibble=%1/16
call :to_hex_char hinibble %hinibble%
set /a lownibble=%1-0x%hinibble%*16
call :to_hex_char lownibble %lownibble%
set hresult=%hinibble%%lownibble%
goto :eof

:to_hex_char
if %2==15 set %1=F
if %2==14 set %1=E
if %2==13 set %1=D
if %2==12 set %1=C
if %2==11 set %1=B
if %2==10 set %1=A
