@ECHO OFF
SETLOCAL
:date to 32 bit value
:example date in ISO-like format
:20211204140528
:encoded 538470AE (or AE708453)
set result=
set isodate=%1

set year=%isodate:~0,4%
set /a year_offset=%year%-1980
call bytetobinary.cmd %year_offset%
set year_token=%result:~-7,7%

if %isodate:~4,1%==0 (set month=%isodate:~5,1%) else (set month=%isodate:~4,2%)
call bytetobinary.cmd %month%
set month_token=%result:~-4,4%

if %isodate:~6,1%==0 (set day=%isodate:~7,1%) else (set day=%isodate:~6,2%)
call bytetobinary.cmd %day%
set day_token=%result:~-5,5%

set lowword=%year_token%%month_token%%day_token%
set lowbyte=%lowword:~0,8%
call binarytobyte.cmd %lowbyte%
set encoded=%encoded%%hresult%
set hibyte=%lowword:~8,8%
call binarytobyte.cmd %hibyte%
set encoded=%encoded%%hresult%


if %isodate:~8,1%==0 (set hour=%isodate:~9,1%) else (set hour=%isodate:~8,2%)
call bytetobinary.cmd %hour%
set hour_token=%result:~-5,5%

if %isodate:~10,1%==0 (set minutes=%isodate:~11,1%) else (set minutes=%isodate:~10,2%)
call bytetobinary.cmd %minutes%
set minutes_token=%result:~-6,6%

if %isodate:~12,1%==0 (set /a dualseconds=%isodate:~13,1%/2) else (set /a dualseconds=%isodate:~12,2%/2)
set /a seconds=%dualseconds%*2
call bytetobinary.cmd %dualseconds%
set dualseconds_token=%result:~-5,5%

set hiword=%hour_token%%minutes_token%%dualseconds_token%
set lowbyte=%hiword:~0,8%
call binarytobyte.cmd %lowbyte%
set encoded=%encoded%%hresult%
set hibyte=%hiword:~8,8%
call binarytobyte.cmd %hibyte%
set encoded=%encoded%%hresult%
set month=0%month%
set month=%month:~-2,2%
set day=0%day%
set day=%day:~-2,2%
set hour=0%hour%
set hour=%hour:~-2,2%
set minutes=0%minutes%
set minutes=%minutes:~-2,2%
set seconds=0%seconds%
set seconds=%seconds:~-2,2%
echo %year%-%month%-%day% %hour%:%minutes%:%seconds% +/- 1 second
set encoded
